﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace mapy
{
    public partial class Form1 : Form
    {
        int x;
        int y;
        int z;
        int posun_x = 0;
        int posun_y = 0;
        int[] mys_dolu = new int[2];
        int[] mys_nahoru = new int[2];
        string server;
        Bitmap b = new Bitmap(768, 768);
        Graphics gr;
        Image[,] mapa = new Image[5,5];
        bool tlac_mys = false;
        System.Net.HttpWebRequest httpWebRequest;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox1.SelectedIndex = 0;
            pictureBox1.MouseWheel += new MouseEventHandler(pictureBox1_MouseWheel);
            pictureBox1.MouseHover += new EventHandler(pictureBox1_MouseHover);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            { 
                x = Int32.Parse(textBox1.Text);
                y = Int32.Parse(textBox2.Text);                
                z = Int32.Parse(comboBox1.Text);

                server = textBox3.Text;

                if (!korekce_souradnic()) //proměnné musí být v daných intervalech
                throw new ArgumentOutOfRangeException();

                posun_x = 0; //nuluju až na konci, mám jistotu, že to projde
                posun_y = 0;


            }catch
            {
                MessageBox.Show("Zadal jsi špatná data.");
            }
            posun_souradnice(); //aby byla vždy mapa přes celou obrazovku
            stahni();
            vykresli();

        }

        private bool korekce_souradnic() //true když je to správně
        {
            if (z < 0 || z > 9 ||
                   x < 0 || y < 0 || x >= 3 * Math.Pow(2, z) || y >= 2 * (Math.Pow(2, z))) //proměnné musí být v daných intervalech
                return false;
            else
                return true;
        }

        private void posun_souradnice()
        {
            if (z != 0) //při nule celá obrazovka nebude
            {
                if (x == 0)
                    x = 1;

                if (y == 0)
                    y = 1;

                if (x > 3 * Math.Pow(2, z)-2)
                    x = 3 * Convert.ToInt32(Math.Pow(2, z))-2;

                if (y > 2 * (Math.Pow(2, z)) - 2)
                    y = 2 * Convert.ToInt32(Math.Pow(2, z)) - 2;
            }
        }

        private void vykresli()
        {
            gr = Graphics.FromImage(b);

            gr.FillRectangle(new SolidBrush(Color.White), 0, 0, 768, 768);

            for (int i = 0; i < 5; i++)
                for (int j = 0; j < 5; j++)
                    if(mapa[i,j] != null)
                        gr.DrawImage(mapa[i, j], (i-1)*256-posun_x, (j-1)*256-posun_y, 256, 256);

            pictureBox1.Image = b;
        }

        private void stahni()
        {
            for(int i=-2;i<3;i++) //stáhni čtverce v okolí 2 od středu
                for (int j = -2; j < 3; j++)
                {
                    mapa[i + 2, j + 2] = null;
                    if (x + i >= 0 && y + j >= 0 && x + i < 3 * Math.Pow(2, z) && y + j < 2 * (Math.Pow(2, z))) //na okraji již nejsou data
                    //mapa[i + 2, j + 2] = 
                    {
                        obrazek(server + "/" + z + "/" + (x + i) + "/" + (y + j) + ".jpg");
                    }
                }
        }

        private void obrazek(string url)// vrať obrázek Image
        {
            httpWebRequest = (HttpWebRequest)HttpWebRequest.Create(url);
            httpWebRequest.BeginGetResponse(new AsyncCallback(stahnuto), null);
            /*HttpWebResponse httpWebReponse = (HttpWebResponse)httpWebRequest.GetResponse();
            Stream stream = httpWebReponse.GetResponseStream();
            */
            //return new Image;
        }

        private void stahnuto(IAsyncResult result)
{
    HttpWebResponse response = (result.AsyncState as HttpWebRequest).EndGetResponse(result) as HttpWebResponse;
           
}

        private void pictureBox1_MouseDown(object sender, MouseEventArgs e)
        {
            mys_dolu[0] = e.X;
            mys_dolu[1] = e.Y;
            tlac_mys = true;
        }

        private void pictureBox1_MouseUp(object sender, MouseEventArgs e)
        {
            tlac_mys = false;
            posun_mapu(e);
        }

        private void pictureBox1_MouseMove(object sender, MouseEventArgs e)
        {
            if (tlac_mys == true && (Math.Abs(e.X - mys_dolu[0]) > 5 || Math.Abs(e.Y - mys_dolu[1]) > 5)) //nepřekresluj moc často
            {
                posun_mapu(e);
            }
        }

        private void posun_mapu(MouseEventArgs e)
        {
            mys_nahoru[0] = e.X;
            mys_nahoru[1] = e.Y;

            //dopočítej posun
            posun_x = posun_x + mys_dolu[0] - mys_nahoru[0];
            posun_y = posun_y + mys_dolu[1] - mys_nahoru[1];
            
            if (Math.Abs(posun_x) >= 256 || Math.Abs(posun_y) >= 256) //hnul se moc, přepočti dlaždice (při absolutní posunu)
            {
                int temp_x = x + posun_x / 256; //jen do tempu, kdybz se neposouval
                int temp_y = y + posun_y / 256;

                if (temp_x > 0 && temp_y > 0 && temp_x + 2 < 3 * Math.Pow(2, z) && temp_y + 2 < 2 * (Math.Pow(2, z))) // tad musí mapa končit u okraje obrazovky, proto musí mapa obsahovat pro všechny části
                {
                    x = temp_x;
                    y = temp_y;
                    posun_x = posun_x % 256;
                    posun_y = posun_y % 256;
                    stahni();
                }
                else
                {
                    posun_x -= mys_dolu[0] - mys_nahoru[0];
                    posun_y -= mys_dolu[1] - mys_nahoru[1];
                }
            }
            vykresli();
            mys_dolu[0] = e.X; mys_dolu[1] = e.Y;
        }

        void pictureBox1_MouseWheel(object sender, MouseEventArgs e)
        {
            int stare_z = z;
            z += e.Delta / 120;
            if (z < 0)
                z = 0;
            if (z > 9)
                z = 9;

            if (stare_z-z<0) //přepočítávej souřadnice
            {
                posun_x = posun_x * Convert.ToInt32(Math.Pow(2, Math.Abs(e.Delta / 120))) + 128;
                posun_y = posun_y * Convert.ToInt32(Math.Pow(2, Math.Abs(e.Delta / 120))) + 128;
                x = x * Convert.ToInt32(Math.Pow(2, Math.Abs(e.Delta / 120))) + posun_x / 256;
                y = y * Convert.ToInt32(Math.Pow(2, Math.Abs(e.Delta / 120))) + posun_y / 256;
                posun_x %= 256;
                posun_y %= 256;
            }
            else if(stare_z-z>0)
            {
                x /= Convert.ToInt32(Math.Pow(2, Math.Abs(e.Delta / 120)));
                y /= Convert.ToInt32(Math.Pow(2, Math.Abs(e.Delta / 120)));
                posun_x /= Convert.ToInt32(Math.Pow(2, Math.Abs(e.Delta / 120)));
                posun_y /= Convert.ToInt32(Math.Pow(2, Math.Abs(e.Delta / 120)));
            }

            stahni(); //aktualizace mapy
            vykresli();
        }
 
 
        void pictureBox1_MouseHover(object sender, EventArgs e)
        {
            pictureBox1.Focus();
        }
    }
}
